// Yoo Jin Shin
// yoojins@andrew.cmu.edu
// Section D
// Final Project

// All scenes global variables
var yaxis = 1;
var xaxis = 2;
var frames = []; 
var frameCounts = 0;
var textSpeed = 3;
var slider;
var sliderValue;

// Yeosu global variables
var c1, c2, c3, c4;
var terrainSpeed1 = 0.0001; 
var terrainDetail1 = 0.003;
var terrainSpeed2 = 0.00012;
var terrainDetail2 = 0.0045;
var terrainSpeed3 = 0.00007;
var terrainDetail3 = 0.0006;
var clouds = []; 
var trees = [];
var textX = 1;
var sunMouse; 
var birdLoad;
var bird1;
var birds = [];

// Grand Canyon global variables
var terrainSpeed4 = 0.00003;
var terrainDetail4 = 0.0005;
var terrainSpeed5 = 0.00012;
var terrainDetail5 = 0.007;
var terrainSpeed6 = 0.00007;
var terrainDetail6 = 0.0065;
var textX3 = 1;
var c9;

// Las Vegas global variables
var c5, c6, c7, c8;
var buildings = [];
var snowflakes = [];
var drops = [];
var textX2 = 1;
var buildingMouse;
var carLoad;
var car1;
var cars = [];

function preload(){
    // Loading sprite sheet for girl character via direct links from imgur
    // Creds to https://www.gameart2d.com/freebies.html
    var filenames = [];
      filenames[0] = "https://i.imgur.com/oEJGbCm.png";
      filenames[1] = "https://i.imgur.com/QsZoWMJ.png";
      filenames[2] = "https://i.imgur.com/kyo4lhi.png";
      filenames[3] = "https://i.imgur.com/XmPYK4a.png";
      filenames[4] = "https://i.imgur.com/w80hQ6A.png";
      filenames[5] = "https://i.imgur.com/0BiNaBy.png";
      filenames[6] = "https://i.imgur.com/WL7kjhR.png";
      filenames[7] = "https://i.imgur.com/z6agkKq.png";
      filenames[8] = "https://i.imgur.com/Vxi5Eu6.png";
      filenames[9] = "https://i.imgur.com/mrjcctG.png";
      filenames[10] = "https://i.imgur.com/oDP8zsr.png";
      filenames[11] = "https://i.imgur.com/DsNFucK.png";
      filenames[12] = "https://i.imgur.com/8Y3e8BW.png";
      filenames[13] = "https://i.imgur.com/aQUjC1v.png";
      filenames[14] = "https://i.imgur.com/6yQMDLO.png";
      filenames[15] = "https://i.imgur.com/fJZPSul.png";
      filenames[16] = "https://i.imgur.com/vghvvNP.png";
      filenames[17] = "https://i.imgur.com/oh2WsXz.png";
      filenames[18] = "https://i.imgur.com/yPh4Upu.png";
      filenames[19] = "https://i.imgur.com/k0wd9HK.png";

    for (var i = 0; i < filenames.length; i++) {
        frames.push(loadImage(filenames[i]));
    }

    // Loading bird and car images created using illustrator
    birdLoad1 = "https://i.imgur.com/RQSUNmm.png";
    bird1 = loadImage(birdLoad1);

    carLoad1 = "https://i.imgur.com/yKCei98.png";
    car1 = loadImage(carLoad1);
}

function setup() {
  createCanvas(480, 480);
  drawSlider();

  // Yeosu: Define gradient colors
  c1 = color(225, 217, 199); // sky top color - grey
  c2 = color(254, 180, 144); // sky bottom color - orange
  c3 = color(50, 50, 2); // ground left - lighter green
  c4 = color(27, 20, 2); // ground right - dark green

  // Yeosu: Initialize clouds
  for (var i = 0; i < 3; i++) {
      var cloudX = random(width); 
      clouds[i] = drawClouds(cloudX);
  }

  // Yeosu: Initialize trees
  for (var i = 0; i < 7; i++) {
    var treeX = random(width);
    var t = drawTrees(treeX);
    trees[i] = t;
  }

  // Yeosu: Initialize birds
  for (var i = 0; i < 7; i++) {
    var birdX = random(width);
    birds[i] = drawBird(birdX);
  }

  // Las Vegas: Define gradient colors
  c5 = color(0, 0, 0); // sky top color - black
  c6 = color(61, 48, 52); // sky bottom color - purpley

  // Las Vegas: Initialize buildings
  for (var i = 0; i < 6; i++) {
      var rx = random(width);
      buildings[i] = drawBuilding(rx);
  }  

  // Las Vegas: Initialize cars
  for (var i = 0; i < 10; i++) {
    var carX = random(width);
    cars[i] = drawCar(carX);
  }
    imageMode(CENTER);
}

function drawSlider() {
  slider = createSlider(5, 60, 30);
  slider.style(200, '100px');
  slider.position(20, 450);
}

function draw() {
  // Set slider to adjust frameRate
  var frameRateSpeed = slider.value();
  frameRate(frameRateSpeed);
  
  // Change scene every 160 frames, then loop
  // Loop: Yeosu - GrandCanyon1 - LasVegas - GrandCanyon2
  if (frameCounts <= 160) { // 160
      drawYeosu();
  }
  else if (frameCounts >= 160 && frameCounts < 320) {
      drawGrandCanyon(); // transition: light to dark sky
  } 
  else if (frameCounts >= 320 && frameCounts < 480) {
    drawLasVegas();
  }
  else if (frameCounts >= 480 && frameCounts < 640) {
    drawGrandCanyon2(); // transition: dark to light sky
  }
  else if (frameCounts === 640) {
    frameCounts = 0;
  }  
  frameCounts++;
}

// =====================================================================
// ==============================YEOSU==================================
// =====================================================================

function drawYeosu() {
  setGradient(0, 0, width, height / 2 + 70, c1, c2, yaxis); // sky
  drawSun();
  drawMountain1();
  drawMountain2();
  drawOcean();
  drawSunReflection();
  updateClouds();
  removeClouds();
  addClouds();
  setGradient(0, 390, width, 480, c3, c4, xaxis); // ground
  updateTrees();
  removeTrees();
  addTrees();
  drawMe();
  drawFog();
  updateBird();
  removeBird();
  addBird();
  writeText();
}

function setGradient(x, y, w, h, c1, c2, axis) {
  // Top to bottom gradient
  if (axis == yaxis) { 
    for (var i = y; i <= y + h; i++) {
      var inter = map(i, y, y + h, 0, 1);
      var c = lerpColor(c1, c2, inter);
      stroke(c);
      line(x, i, x + w, i);
    }
  }
  // Left to right gradient
  else if (axis == xaxis) {
    for (var i = x; i <= x + w; i++) {
      var inter = map(i, x, x + w, 0, 1);
      var c = lerpColor(c1, c2, inter);
      stroke(c);
      line(i, y, i, y + h);
    }
  }
}

function drawMountain1(){
  noStroke();
  fill(204, 157, 135); 
  beginShape(); 
  for (var x = 0; x < width; x++) {
    var t = (x * terrainDetail1) + (millis() * terrainSpeed1);
    var y = map(noise(t), 0, 1.8, height / 4 - 10, height);
    vertex(x, y); 
  }
  vertex(width, height);
  vertex(0, height);
  endShape();
}

function drawFog() { 
  for (var y = 200; y < height + 5; y++) {
    var f = map(y, height / 2 - 40, 550, 0, 100);
    stroke(255, f);
    line(0, y, width, y);
  }
}

function drawMountain2(){
  fill(147, 126, 115); 
    noStroke();
    beginShape(); 
      for (var x = 0; x < width; x++) {
            var t = (x * terrainDetail2) + (millis() * terrainSpeed2);
            var y = map(noise(t), 0, 2, height / 4 + 60, height);
            vertex(x, y); 
      }
      vertex(width,height);
      vertex(0,height);
    endShape();
}

function drawOcean() {
    fill(170, 146, 121); 
    noStroke();
    beginShape(); 
      for (var x = 0; x < width; x++) {
            var t = (x * terrainDetail3) + (millis() * terrainSpeed3);
            var y = map(noise(t), 0, 2, height - 230, height);
            vertex(x, y); 
      }
      vertex(width, height);
      vertex(0, height);
    endShape();
}

function drawSun() {
	// All sun parts based on mouseY
  	sunMouse = constrain(mouseY, 0, height / 3 + 30);
    noStroke();
    // Sunglow
    // Color less intense and size smaller as sun goes farther up
    fill(253, 254 - sunMouse, 221 - sunMouse, 20 - sunMouse*0.02);
    ellipse(width / 3, sunMouse + 40, sunMouse - 10, sunMouse - 10);
    fill(253, 254 - sunMouse, 221 - sunMouse, 20 - sunMouse*0.03);
    ellipse(width / 3, sunMouse + 40, sunMouse*1.1, sunMouse*1.1);
    fill(253, 254 - sunMouse, 221 - sunMouse, 20 - sunMouse*0.05);
    ellipse(width / 3, sunMouse + 40, sunMouse*1.2 + 10, sunMouse*1.2 + 10);
    // Sunrays
    fill(253, 254, 221, 30);
    triangle(width / 3, sunMouse + 20, width / 3 - 40, height / 3 + 90, width / 3 - 10, height /3 + 80); // left big
    triangle(width / 3, sunMouse + 20, width / 3 + 40, height / 3 + 80, width / 3 + 10, height /3 + 70); // right big
    triangle(width / 3, sunMouse + 20, width / 3 - 50, height / 3 + 90, width / 3 - 30, height /3 + 80); // left small
    triangle(width / 3, sunMouse + 20, width / 3 + 50, height / 3 + 80, width / 3 + 30, height /3 + 70); // right small
    triangle(width / 3, sunMouse + 20, width / 3 - 70, height / 3 + 70, width / 3 - 80, height /3 + 70); // left small2
    triangle(width / 3, sunMouse + 20, width / 3 + 70, height / 3 + 90, width / 3 + 80, height /3 + 80); // right small2
    // Sun
    fill(253, 254, 221, sunMouse + 30);
    ellipse(width / 3, sunMouse + 40, sunMouse - 20, sunMouse - 20);
}

function drawSunReflection() { 
	// Size of reflection on ocean corresponds to sun size/distance away
    var x = 10;
    var y = 47;
    var w = sunMouse;
    var h = 10;
    noStroke();
    // Outer darker glow
    fill(248, 172, 137, 100);
    push();
    rectMode(CENTER);
    rect(width / 3, 2 * height / 3 + y, w, h, 10);
    rect(width / 3, 2 * height / 3 + y - 13, w * 0.8, h, 10);
    rect(width / 3, 2 * height / 3 + y - 26, w * 0.6, h, 10);
    // Inner lighter glow
    fill(253, 254, 221, 50);
    rect(width / 3, 2 * height / 3 + y - 4, w * 0.9, h * 0.8, 10);
    rect(width / 3, 2 * height / 3 + y - 17, w * 0.7, h * 0.8, 10);
    rect(width / 3, 2 * height / 3 + y - 30, w * 0.5, h * 0.8, 10);
    pop();
}

function updateClouds(){
  for (var i = 0; i < clouds.length; i++) {
    clouds[i].move();
    clouds[i].display();
  }
}

function removeClouds(){
  var keepClouds = [];
  for (var i = 0; i < clouds.length; i++) {
      if (clouds[i].x - this.width / 2 < width) {
        keepClouds.push(clouds[i]);
      }
  }
  clouds = keepClouds;
}

function addClouds(){
  var newCloud = 0.01;
  if (random(0, 1) < newCloud) {
    clouds.push(drawClouds(random(width)))
  }
}

function moveClouds(){
  this.x += this.speed;
}

function displayClouds(){
  var b = random(165, 180);
  fill(255, 240, 240, 30);
  ellipse(this.x, this.y, this.width, this.height);
  ellipse(this.x + 50, this.y + 10, this.width - 20, this.height - 70);
  ellipse(this.x - 50, this.y - 5, this.width - 70, this.height - 10);
}

function drawClouds(newCloudX) {
  var cloud = {
    x: newCloudX,
    y: random(30, height / 2),
    width: random(150, 250), 
    height: random(20, 50),
    speed: random(0.5, 1.5),
    move: moveClouds,
    display: displayClouds
  }
  return cloud;          
}

function updateTrees() {
  for (var i = 0; i < trees.length; i++) { 
    trees[i].move();
    trees[i].display();
  }
}

function removeTrees() {
  var keepTrees = [];
  for (var i = 0; i < trees.length; i++) {
    if (trees[i].x < width) {
      keepTrees.push(trees[i]);
    }
  }
  trees = keepTrees;
}

function addTrees() {
  var newTree = 0.02;
  if (random(0, 1) < newTree) {
    trees.push(drawTrees(random(width)));
  }
}

function moveTrees() {
  this.x += this.speed;
}

function displayTrees() {
  // Tree height based on mouseY, mapped to a reasonable extent
  var treeMouse = map(mouseY, 0, height, height / 3, 0);
  var treeMouseCon = constrain(treeMouse, 0, height)
  // Trunk
  stroke(c4);
  strokeWeight(4);
  line(this.x, this.y + 20 - treeMouseCon, this.x, this.y + 40);
  // Leaves
  fill(c3, 20);
  stroke(c3);
  strokeWeight(7);
  strokeJoin(ROUND);
  triangle(this.x, this.y - treeMouseCon, this.x + 20, this.y + 25, this.x - 20, this.y + 25);
  // Add snow if on Grand Canyon scene
  if (frameCounts >= 160 && frameCounts < 320 || frameCounts >= 480 && frameCounts < 640) {
    fill(250);
    stroke(250);
    triangle(this.x, this.y - treeMouseCon - 10, this.x + 11, this.y - treeMouseCon / 2 + 5, this.x - 11, this. y - treeMouseCon / 2 + 5);
  }
}

function drawTrees(newTreeX) {
  var trees = {
    x: newTreeX,
    y: 350,
    speed: random(0.5, 3),
    move: moveTrees,
    display: displayTrees
  }
  return trees;
}

function updateBird() {
  for (var i = 0; i < birds.length; i++) {
    birds[i].move();
    birds[i].display();
  }
}

function removeBird(){
  var keepBirds = [];
  for (var i = 0; i < birds.length; i++) {
      if (birds[i].x < width * 2) {
        keepBirds.push(birds[i]);
      }
  }
  birds = keepBirds;
}

function addBird(){
  var newBird = 0.01;
  if (random(0, 1) < newBird) {
    birds.push(drawBird(random(width)));
  }
}

function moveBird(){
  this.x += this.speed;
}

function displayBird() {
  push();
  scale(this.size, this.size);
  translate(this.x, this.y);
  tint(255, 120);
  image(bird1, 0, 0);
  pop();
}

function drawBird(newBirdX) {
  var bird = {
    x: newBirdX,
    y: random(30, height / 2),
    size: random(0.3, 0.8),
    speed: random(0.5, 2),
    move: moveBird,
    display: displayBird
  }
  return bird;          
}

function writeText() {
  textFont("Helvetia");
  noStroke();
  textSize(20);
  fill(255);
  text("Y E O S U,  S O U T H  K O R E A", textX, 50);
  if (textX <= width) {
    textX += textSpeed;
  } else textX = 1;
}

function drawMe() { // girl character in the middle
  push();
    translate(width / 2, 390);
    scale(.1, .1);
    image(frames[frameCount % 20], 0, 0);
    pop();    
}

// =====================================================================
// ==============================LAS VEGAS==============================
// =====================================================================

function drawLasVegas() {
  setGradient(0, 0, width, height, c6, c5, yaxis); // sky
  displayHorizon();
  building();
  updateCar();
  removeCar();
  addCar();
  writeText2();
  drawMe();
  drawMeReflection();
  drawRain();
}

function building() { 
  push();
    translate(0.1 * width, 0.1 * height); 
    scale(0.8);
    updateBuilding();
    removeBuilding();
    addBuilding(); 
  pop();
}

function updateBuilding(){
  for (var i = 0; i < buildings.length; i++){
    buildings[i].move();
    buildings[i].display();
  }
}

function removeBuilding(){
  var keepBuilding = [];
  for (var i = 0; i < buildings.length; i++){
    if (buildings[i].x + buildings[i].breadth > 0) {
        keepBuilding.push(buildings[i]);
    }
  }
  buildings = keepBuilding; 
}

function addBuilding() {
  var newBuilding = 0.015; 
  if (random(0, 1) < newBuilding) {
      buildings.push(drawBuilding(width));
  }
}

function moveBuilding() {
  this.x += this.speed;
}
    
function displayBuilding() {
  var floorHeight = 40;
  // Building height based on mouseY
  buildingMouse = 1.3 * map(mouseY, 0, height, height - 390, 0);
  var buildingMouseCon = constrain(buildingMouse, 0, height)
  var bHeight = this.nFloors * floorHeight + buildingMouseCon; 
  fill(0);
  noStroke();
  push();
  translate(this.x, height - 40);
  // Background buildings
  fill(0, 40);
  rect(200, -bHeight * 1.5 - 12, this.breadth + 40, bHeight + 200);
  fill(0, 60);
  rect(100, -bHeight * 1.3 - 12, this.breadth + 20, bHeight + 200);
  // Main layer buildings
  fill(0);
  rect(0, -bHeight - 12, this.breadth, bHeight);
  // Building reflection
  fill(0, 100);
  rect(0, bHeight - 12, this.breadth, - bHeight);
  // Building Windows
  noStroke();
  var R = random(150, 255);
  var G = random(150, 255);
  var B = random(150, 255);
  fill(R, G, B); 
  for (var i = 0; i < this.nFloors - 1; i++) {
    if (random (0, 1) < 0.3) {
      rect(5, -50 - buildingMouseCon - (i * (floorHeight)), this.breadth - 10, random(15, 40));
    }
  }
  // Reflection windows
  fill(R, G, B, 80);
  for (var i = 0; i < 2; i++) {
    if (random (0, 1) < 0.3) {
      rect(5, 50 - (i * (floorHeight)), this.breadth - 10, random(15, 40));
    }
  }
  pop();
}

function drawBuilding(newBuildingX) {
  var bldg = {
    x: newBuildingX,
    breadth: round(random(70, 160)),
    speed: -2,
    nFloors: round(random(3, 10)),
    move: moveBuilding,
    display: displayBuilding
  }
  return bldg;
}

function displayHorizon(){
  noStroke();
  //fill(0);
  fill(20, 16, 18);
  rect(0, 390, width, height); 
}

function drawMeReflection() {
  push();
    translate(width / 2, 430);
    scale(.1, -.1);
    tint(255, 30);
    image(frames[frameCount % 20], 0, 0);
  pop();   
}

function writeText2() {
  textFont("Helvetia");
  noStroke();
  textSize(20);
  fill(255);
  text("L A S  V E G A S,  N E V A D A", textX2, 50);
  if (textX2 <= width) {
    textX2 += textSpeed;
  } else textX2 = 1;
}

function updateCar(){
  for (var i = 0; i < cars.length; i++) {
    cars[i].move();
    cars[i].display();
  }
}

function removeCar(){
  var keepCars = [];
  for (var i = 0; i < cars.length; i++) {
      if (cars[i].x < width * 2 + 50) {
        keepCars.push(cars[i]);
      }
  }
  cars = keepCars;
}

function addCar(){
  var newCar = 0.7;
  if (random(0, 1) < newCar) {
    cars.push(drawCar(random(width)));
  }
}

function moveCar(){
  this.x += this.speed;
}

function displayCar() {
  push();
  scale(this.size, this.size);
  translate(this.x, this.y);
  tint(255, 255);
  image(car1, 0, 0);
  pop();
}

function drawCar(newCarX) {
  var car = {
    x: newCarX,
    y: height * 2.2,
    //breadth: 10,
    size: random(0.4, 1),
    speed: random(10, 20),
    move: moveCar,
    display: displayCar
  }
  return car;          
}

// Rain effect
// Creds to https://code.sololearn.com/WhmdLzp9HjDe/#js
function drawRain() {
	var drops  = [];
	// Initialize rain drops
	for(var i = 0; i < 400; i++) {
		drops[i] = new rain();
	}
  	c7 = color(30, 30, 50);
  	c8 = color(0, 150);
  	for(var i = 0; i < drops.length; i++){
		drops[i].move();
		drops[i].display();
  }
}

function rain() {
	// Display drops
	this.x = random(0,width);
	this.y = random(-10, height);
	this.d = 2;
	this.h = random(2, 10);
	this.col= map(this.h, 2, 10, 100, 255);
	this.display = function() {
		noStroke();
		fill(this.col,100);
		ellipse(this.x, this.y, this.d, this.h);
	}
	// Move drops
	this.vel = 0;
	this.grv = map(this.h, 2, 10, 3, 10);
	this.off = map(this.h, 2, 10, height / 2, height);
	this.move = function(){
		this.y += this.vel;
		this.vel = this.grv;
		if(this.y > this.off){
			this.y = -10;
		}
	}
}

// =====================================================================
// =====================TRANSITION:GRAND CANYON=========================
// =====================================================================

function drawGrandCanyon() { // from Yeosu, sky light to dark
  c9 = color(240, 198, 171);
  setGradient(0, 0, width, height / 2 + 70, c9, c5, xaxis); // sky
  drawMountain4();
  drawMountain5();
  drawMountain6();
  updateClouds();
  removeClouds();
  addClouds();
  updateTrees();
  removeTrees();
  addTrees();
  setGradient(0, 390, width, 480, c9, c3, xaxis); // ground
  drawMe();
  drawFog2();
  writeText3();
  drawSnowflake();
}

function drawGrandCanyon2() { // from Las Vegas, sky dark to light
  setGradient(0, 0, width, height / 2 + 70, c5, c9, xaxis); // sky
  drawMountain4();
  drawMountain5();
  drawMountain6();
  updateClouds();
  removeClouds();
  addClouds();
  updateTrees();
  removeTrees();
  addTrees();
  setGradient(0, 390, width, 480, c3, c9, xaxis); // ground
  drawMe();
  drawFog2();
  writeText3();
  drawSnowflake();
}

function drawFog2() { 
  for (var y = 200; y < height; y++) {
    var f = map(y, height / 2 - 40, 550, 0, 70);
    stroke(0, f); // dark fog to ease transition
    line(0, y, width, y);
  }
}

function drawMountain4(){
  noStroke();
  fill(135, 119, 146, 100); // purpley
  beginShape(); 
  for (var x = 0; x < width; x++) {
    var t = (x * terrainDetail4) + (millis() * terrainSpeed4);
    var y = map(noise(t), 0, 1.8, height / 4 - 50, height);
    vertex(x, y); 
  }
  vertex(width, height);
  vertex(0, height);
  endShape();
}

function drawMountain5(){
  noStroke();
  fill(193, 150, 150, 150); // pinkish
  beginShape(); 
  for (var x = 0; x < width; x++) {
    var t = (x * terrainDetail5) + (millis() * terrainSpeed5);
    var y = map(noise(t), 0, 1.8, height / 4 + 20, height);
    vertex(x, y); 
  }
  vertex(width, height);
  vertex(0, height);
  endShape();
}

function drawMountain6(){
  noStroke();
  fill(238, 164, 136, 180); // orangey
  beginShape(); 
  for (var x = 0; x < width; x++) {
    var t = (x * terrainDetail6) + (millis() * terrainSpeed6);
    var y = map(noise(t), 0, 1.8, height / 4 + 100, height);
    vertex(x, y); 
  }
  vertex(width, height);
  vertex(0, height);
  endShape();
}

function writeText3() {
  textFont("Helvetia");
  noStroke();
  textSize(20);
  fill(255);
  text("G R A N D  C A N Y O N,  A R I Z O N A", textX3, 50);
  if (textX3 <= width) {
    textX3 += textSpeed;
  } else textX3 = 1;
}

// Snow effect
// Creds to https://p5js.org/examples/simulate-snowflakes.html
function drawSnowflake() {
  let t = frameCount / 60; // update time
  // create a random number of snowflakes each frame
  for (var i = 0; i < random(5); i++) {
    snowflakes.push(new snowflake()); // append snowflake object
  }
  // loop through snowflakes with a for..of loop
  for (let flake of snowflakes) {
    flake.update(t); // update snowflake position
    flake.display(); // draw snowflake
  }
}

function snowflake() {
  // initialize coordinates
  this.posX = 0;
  this.posY = random(-50, 0);
  this.initialangle = random(0, 2 * PI);
  this.size = random(2, 5);
  // radius of snowflake spiral
  // chosen so the snowflakes are uniformly spread out in area
  this.radius = sqrt(random(pow(width / 2, 2)));
  this.update = function(time) {
    // x position follows a circle
    let w = 0.6; // angular speed
    let angle = w * time + this.initialangle;
    this.posX = width / 2 + this.radius * sin(angle);
    // different size snowflakes fall at slightly different y speeds
    this.posY += pow(this.size, 0.5);
    // delete snowflake if past end of screen
    if (this.posY > height) {
      let index = snowflakes.indexOf(this);
      snowflakes.splice(index, 1);
    }
  };
  this.display = function() {
    noStroke();
    fill(255, 200);
    ellipse(this.posX, this.posY, this.size);
  }
}

// SPECIAL THANKS TO RAIN & SIMIN!!!!
